# \alpha-rank

\alpha-rank is a unified ranking algorithm to achieve the goal of item fairness.



## Model

To run the \alpha-rank model, you need to run the `run_alpha-rank.py`.(with default setting)

```
python run_alpha-rank.py
```

If you want to change the experimental setting, you can choose to determine the parameters as followed:

| parameter | type  | range         | detail                                                       |
| --------- | ----- | :------------ | :----------------------------------------------------------- |
| U         | int   | [1 ,+inf)     | The size of users of the dataset you want to select          |
| I         | int   | [1 ,+inf)     | The size of items of the dataset you want to select          |
| mode      | str   | {'ad', 'rec'} | 'ad' if you want to run \alpha-rank on the advertising dataset(ipinyou);  'rec' if you want to run \alpha-rank on the recommendation dataset(yelp) |
| topk      | int   | [1,U]         | the size of the recommendation list                          |
| alpha     | float | [0,+inf)      | the hyperparameter of \alpha-rank to trade-off between accuracy and fairness |
| k         | float | (0, +inf)     | the hyperparameter to determine the size of eta              |
| lbd       | float | (0,+inf)      | the coefficient in OT projection to determine the smoothness  and the convexity of the distribution OT solution |

Here we give a example of run the model using self-determined parameter setting:

```python
python run_alpha-rank.py --U=503 --I=314 --mode=rec --topk=10 --alpha=1 --k=0.1 --lbd=1 
```
